SystemOrganization addCategory: #POO!

TestCase subclass: #XXTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'POO'!

!XXTest methodsFor: 'as yet unclassified' stamp: 'HernanWilkinson 4/17/2013 21:23'!
test01WhenAHolidayCalendarIsCreatedAllDateAreWorkingDates
"
when....then...should...
testWhenCreatedThenAllDatesShouldBeWorkingDates
"

	| holidayCalendar aDate |
	
	holidayCalendar := HolidayCalendar new.
	aDate := Date today.
	
	self deny: (holidayCalendar isHoliday: aDate)! !

!XXTest methodsFor: 'as yet unclassified' stamp: 'HernanWilkinson 4/17/2013 21:49'!
test02

	| holidayCalendar aSunday |
	
	holidayCalendar := HolidayCalendar new.
	aSunday := Date newDay: 14 month: 4 year: 2013.
	holidayCalendar addHolidayRule: (DayOfWeekHolidayRule for: #Sunday).
	
	self assert: (holidayCalendar isHoliday: aSunday)! !

!XXTest methodsFor: 'as yet unclassified' stamp: 'HernanWilkinson 4/17/2013 21:49'!
test03

	| holidayCalendar aSunday aSaturday |
	
	holidayCalendar := HolidayCalendar new.
	aSunday := Date newDay: 14 month: 4 year: 2013.
	aSaturday := Date newDay: 13 month: 4 year: 2013.
	holidayCalendar addHolidayRule: (DayOfWeekHolidayRule for: #Sunday).
	holidayCalendar addHolidayRule: (DayOfWeekHolidayRule for:  #Saturday).
	
	self assert: (holidayCalendar isHoliday: aSunday).
	self assert: (holidayCalendar isHoliday: aSaturday).! !

!XXTest methodsFor: 'as yet unclassified' stamp: 'HernanWilkinson 4/17/2013 21:48'!
test04

	| holidayCalendar aChristmas |
	
	holidayCalendar := HolidayCalendar new.
	aChristmas := Date newDay: 25 month: 12 year: 2013.
	holidayCalendar addHolidayRule: (DayOfMonthHolidayRule for: (DayOfMonth of: 12 day: 25)).

	self assert: (holidayCalendar isHoliday: aChristmas).
	! !

!XXTest methodsFor: 'as yet unclassified' stamp: 'HernanWilkinson 4/17/2013 21:48'!
test05

	| holidayCalendar aChristmas |
	
	holidayCalendar := HolidayCalendar new.
	aChristmas := Date newDay: 25 month: 12 year: 2013.
	holidayCalendar addHolidayRule: (DayOfMonthHolidayRule for: (DayOfMonth of: 1 day:1)).

	self deny: (holidayCalendar isHoliday: aChristmas).
	! !

!XXTest methodsFor: 'as yet unclassified' stamp: 'HernanWilkinson 4/17/2013 21:47'!
test06

	| holidayCalendar aDate |
	
	holidayCalendar := HolidayCalendar new.
	aDate := Date newDay: 24 month: 12 year: 2013.
	holidayCalendar addHolidayRule: (DateHolidayRule for: aDate).

	self assert: (holidayCalendar isHoliday: aDate).
	! !

!XXTest methodsFor: 'as yet unclassified' stamp: 'HernanWilkinson 4/17/2013 21:47'!
test07

	| holidayCalendar aDate |
	
	holidayCalendar := HolidayCalendar new.
	aDate := Date newDay: 24 month: 12 year: 2013.
	holidayCalendar addHolidayRule: (DateHolidayRule for: aDate next).

	self deny: (holidayCalendar isHoliday: aDate).
	! !

!XXTest methodsFor: 'as yet unclassified' stamp: 'HernanWilkinson 4/17/2013 21:57'!
test08

	| holidayCalendar aDate |
	
	holidayCalendar := HolidayCalendar new.
	aDate := Date newDay: 14 month: 4 year: 2013.
	holidayCalendar addHolidayRule: (BoundedHolidayRule 
		between: (Date newDay: 24 month: 12 year: 2011) 
		and: (Date newDay: 24 month: 12 year: 2012) 
		for: (DayOfWeekHolidayRule for: #Sunday)).

	self deny: (holidayCalendar isHoliday: aDate).
	! !

!XXTest methodsFor: 'as yet unclassified' stamp: 'HernanWilkinson 4/18/2013 14:39'!
test09

	| holidayCalendar aDate |
	
	holidayCalendar := HolidayCalendar new.
	aDate := Date newDay: 15 month: 4 year: 2012.
	holidayCalendar addHolidayRule: (BoundedHolidayRule 
		between: (Date newDay: 24 month: 12 year: 2011) 
		and: (Date newDay: 24 month: 12 year: 2012) 
		for: (DayOfWeekHolidayRule for: #Sunday)).

	self assert: (holidayCalendar isHoliday: aDate).
	! !

!XXTest methodsFor: 'as yet unclassified' stamp: 'PabloRago 4/22/2013 17:50'!
test10

	"comment stating purpose of message"

	| aHolidayRule fuck |	
	aHolidayRule := HolidayRule	 new.
	fuck := aHolidayRule foo. 							
	self assert: (fuck = 'fuck' ).! !

Object subclass: #Calzon
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'POO'!

Object subclass: #DayOfMonth
	instanceVariableNames: 'monthNumber dayNumber'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'POO'!

!DayOfMonth class methodsFor: 'instance creation' stamp: 'HernanWilkinson 4/17/2013 21:04'!
of: aMonthNumber day: aDayNumber

	^ self new initializeOf: aMonthNumber day: aDayNumber ! !

!DayOfMonth methodsFor: 'as yet unclassified' stamp: 'HernanWilkinson 4/17/2013 21:10'!
= anObject

	^ (anObject isKindOf: self class) and: [ 
		dayNumber = anObject dayNumber and: [monthNumber = anObject monthNumber ]]! !

!DayOfMonth methodsFor: 'as yet unclassified' stamp: 'HernanWilkinson 4/17/2013 21:11'!
dayNumber
	
	^ dayNumber! !

!DayOfMonth methodsFor: 'as yet unclassified' stamp: 'HernanWilkinson 4/17/2013 21:11'!
hash

	^ dayNumber hash bitXor: monthNumber hash! !

!DayOfMonth methodsFor: 'as yet unclassified' stamp: 'HernanWilkinson 4/17/2013 21:04'!
initializeOf: aMonthNumber day: aDayNumber 

	monthNumber := aMonthNumber.
	dayNumber := aDayNumber ! !

!DayOfMonth methodsFor: 'as yet unclassified' stamp: 'HernanWilkinson 4/17/2013 21:12'!
monthNumber
	
	^ monthNumber! !

Object subclass: #HolidayCalendar
	instanceVariableNames: 'holidayRules'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'POO'!

!HolidayCalendar methodsFor: 'as yet unclassified' stamp: 'HernanWilkinson 4/17/2013 21:47'!
addHolidayRule: aHolidayRule
	
	holidayRules add: aHolidayRule ! !

!HolidayCalendar methodsFor: 'as yet unclassified' stamp: 'HernanWilkinson 4/17/2013 21:45'!
initialize

	holidayRules := Set new.
	! !

!HolidayCalendar methodsFor: 'as yet unclassified' stamp: 'HernanWilkinson 4/17/2013 21:45'!
isHoliday: aDate
	^ holidayRules anySatisfy: [ :aHolidayRule | aHolidayRule isHoliday: aDate ]! !

Object subclass: #HolidayRule
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'POO'!

HolidayRule subclass: #BoundedHolidayRule
	instanceVariableNames: 'from to rule'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'POO'!

!BoundedHolidayRule class methodsFor: 'as yet unclassified' stamp: 'HernanWilkinson 4/17/2013 21:58'!
between: from and: to for: aRule 

	^self new initializeBetween: from and: to for: aRule! !

!BoundedHolidayRule methodsFor: 'as yet unclassified' stamp: 'HernanWilkinson 4/17/2013 21:58'!
initializeBetween: aFrom and: aTo for: aRule

	from := aFrom.
	to := aTo .
	rule := aRule ! !

!BoundedHolidayRule methodsFor: 'as yet unclassified' stamp: 'HernanWilkinson 4/17/2013 21:59'!
isHoliday: aDate

	^ (aDate between: from and: to) and: [rule isHoliday: aDate]! !

HolidayRule subclass: #DateHolidayRule
	instanceVariableNames: 'date'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'POO'!

!DateHolidayRule class methodsFor: 'as yet unclassified' stamp: 'HernanWilkinson 4/17/2013 21:43'!
for: aDate 
	
	^ self new initializeFor: aDate! !

!DateHolidayRule methodsFor: 'as yet unclassified' stamp: 'HernanWilkinson 4/17/2013 21:44'!
initializeFor: aDate 
	
	date := aDate! !

!DateHolidayRule methodsFor: 'as yet unclassified' stamp: 'HernanWilkinson 4/17/2013 21:44'!
isHoliday: aDate 
	
	^ aDate = date! !

HolidayRule subclass: #DayOfMonthHolidayRule
	instanceVariableNames: 'dayOfMonth'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'POO'!

!DayOfMonthHolidayRule class methodsFor: 'as yet unclassified' stamp: 'HernanWilkinson 4/17/2013 21:41'!
for: aDayOfMonth 
	
	^self new initializeFor: aDayOfMonth ! !

!DayOfMonthHolidayRule methodsFor: 'as yet unclassified' stamp: 'HernanWilkinson 4/17/2013 21:41'!
initializeFor: aDayOfMonth 

	dayOfMonth := aDayOfMonth ! !

!DayOfMonthHolidayRule methodsFor: 'as yet unclassified' stamp: 'HernanWilkinson 4/17/2013 21:42'!
isHoliday: aDate 
	
	^ aDate asDayOfMonth = dayOfMonth ! !

HolidayRule subclass: #DayOfWeekHolidayRule
	instanceVariableNames: 'dayOfWeek'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'POO'!

!DayOfWeekHolidayRule class methodsFor: 'as yet unclassified' stamp: 'HernanWilkinson 4/17/2013 21:36'!
for: aDayOfWeek

	^ self new initializeFor: aDayOfWeek ! !

!DayOfWeekHolidayRule methodsFor: 'as yet unclassified' stamp: 'HernanWilkinson 4/17/2013 21:37'!
initializeFor: aDayOfWeek 

	dayOfWeek := aDayOfWeek ! !

!DayOfWeekHolidayRule methodsFor: 'as yet unclassified' stamp: 'HernanWilkinson 4/17/2013 21:39'!
isHoliday: aDate 

	^aDate weekday = dayOfWeek ! !

!HolidayRule methodsFor: 'as yet unclassified' stamp: 'PabloRago 4/22/2013 17:41'!
foo
	^ 'fuck'.! !

!HolidayRule methodsFor: 'as yet unclassified' stamp: 'HernanWilkinson 4/17/2013 21:55'!
isHoliday: aDate

	self subclassResponsibility ! !
